# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2022/7/5
import random
import time
import requests
import urllib3
from main.common import Common
from main.feishu_lib import Feishu
from main.publish import Publish

proxies = {"http": None, "https": None}


class Person:
    # 小程序关注列表翻页参数
    wechat_follow_start_t = None
    # 小程序个人主页视频列表翻页参数
    wechat_person_start_t = None
    # 视频发布时间
    send_time = 0
    # 配置微信
    wechat_sheet = Feishu.get_values_batch("follow", "xiaoniangao", "dzcWHw")
    follow_x_mid = wechat_sheet[2][3]
    follow_x_token_id = wechat_sheet[3][3]
    follow_referer = wechat_sheet[4][3]
    follow_uid = wechat_sheet[5][3]
    follow_token = wechat_sheet[6][3]

    # 过滤敏感词
    @classmethod
    def sensitive_words(cls, log_type):
        # 敏感词库列表
        word_list = []
        # 从云文档读取所有敏感词，添加到词库列表
        lists = Feishu.get_values_batch(log_type, "xiaoniangao", "DRAnZh")
        for i in lists:
            for j in i:
                # 过滤空的单元格内容
                if j is None:
                    pass
                else:
                    word_list.append(j)
        return word_list

    # 基础门槛规则
    @staticmethod
    def download_rule(d_duration, d_width, d_height, d_play_cnt, d_share_cnt):
        """
        下载视频的基本规则
        :param d_duration: 时长
        :param d_width: 宽
        :param d_height: 高
        :param d_play_cnt: 播放量
        :param d_share_cnt: 分享量
        :return: 满足规则，返回 True；反之，返回 False
        """
        # 视频时长
        if int(float(d_duration)) >= 60:
            # 宽或高
            if int(d_width) >= 0 or int(d_height) >= 0:
                # 播放量
                if int(d_play_cnt) >= 1000:
                    # 分享量
                    if int(d_share_cnt) >= 0:
                        return True
                    else:
                        return False
                else:
                    return False
            else:
                return False
        else:
            return False

    # 从小程序中,关注用户列表同步至云文档
    @classmethod
    def get_sub_or_fans_list(cls, log_type):
        try:
            follow_list = []
            follow_sheet = Feishu.get_values_batch(log_type, "xiaoniangao", "oNpThi")
            url = "https://api.xiaoniangao.cn/account/get_sub_or_fans_list"
            headers = {
                "X-Mid": str(cls.follow_x_mid),
                "X-Token-Id": str(cls.follow_x_token_id),
                "content-type": "application/json",
                "uuid": str(cls.follow_uid),
                "Accept-Encoding": "gzip,compress,br,deflate",
                "User-Agent": "Mozilla/5.0 (iPhone; CPU iPhone OS 14_7_1 like Mac OS X)"
                              " AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 "
                              "MicroMessenger/8.0.20(0x18001435) NetType/WIFI Language/zh_CN",
                "Referer": str(cls.follow_referer)
            }
            json_text = {
                "visited_mid": str(cls.follow_x_mid),
                "start_t": cls.wechat_follow_start_t,
                "limit": 20,
                "h_qs": "imageMogr2/gravity/center/rotate/$/thumbnail/!84x84r/crop/84x84/interlace/1/format/jpg",
                "type": 1,
                "token": str(cls.follow_token),
                "uid": str(cls.follow_uid),
                "proj": "ma",
                "wx_ver": "8.0.23",
                "code_ver": "3.68.0",
                "log_common_params": {
                    "e": [{
                        "data": {
                            "page": "followFansPage"
                        }
                    }],
                    "ext": {
                        "brand": "iPhone",
                        "device": "iPhone 11",
                        "os": "iOS 14.7.1",
                        "weixinver": "8.0.23",
                        "srcver": "2.24.7",
                        "net": "wifi",
                        "scene": "1089"
                    },
                    "pj": "1",
                    "pf": "2",
                    "session_id": "7468cf52-00ea-432e-8505-6ea3ad7ec164"
                }
            }
            r = requests.post(url=url, headers=headers, json=json_text, proxies=proxies, verify=False)
            if "data" not in r.json():
                Common.logger(log_type).warning("从小程序中获取关注用户列表:{}", r.text)
            else:
                users = r.json()["data"]["list"]
                for i in range(len(users)):
                    profile_mid = users[i]["mid"]
                    nick = users[i]["nick"]
                    follow_list.append(profile_mid)
                    # 同步已关注的用户至云文档
                    if profile_mid not in [j for i in follow_sheet for j in i]:
                        Feishu.insert_columns(log_type, "xiaoniangao", "oNpThi", "ROWS", 1, 2)
                        time.sleep(1)
                        values = [[profile_mid, nick]]
                        Feishu.update_values(log_type, "xiaoniangao", "oNpThi", "B2:C2", values)
                    else:
                        Common.logger(log_type).info("用户:{}，在云文档中已存在", nick)
            cls.wechat_follow_start_t = r.json()["data"]["next_t"]
            # 翻页，直至到底了
            if cls.wechat_follow_start_t != 0:
                cls.get_sub_or_fans_list(log_type)
            else:
                Common.logger(log_type).info("从小程序中同步关注用户至云文档完成\n")
            return follow_list
        except Exception as e:
            Common.logger(log_type).error("从小程序中,关注用户列表同步至云文档异常:{}", e)

    # 从云文档获取关注用户列表
    @classmethod
    def get_follow_users(cls, log_type):
        try:
            follow_sheet = Feishu.get_values_batch(log_type, "xiaoniangao", "oNpThi")
            if len(follow_sheet) == 1:
                Common.logger(log_type).info("暂无定向爬取账号")
            else:
                follow_list = []
                nick_list = []
                for i in range(1, len(follow_sheet)):
                    profile_mid = follow_sheet[i][1]
                    nick = follow_sheet[i][2]
                    nick_list.append(nick)
                    follow_list.append(profile_mid)
                Common.logger(log_type).info("关注用户列表:{}", nick_list)
                return follow_list
        except Exception as e:
            Common.logger(log_type).error("从云文档获取关注用户列表异常:{}", e)

    # 从云文档获取取消关注用户列表
    @classmethod
    def get_unfollow_users(cls, log_type):
        try:
            unfollow_sheet = Feishu.get_values_batch(log_type, "xiaoniangao", "tuMNhn")
            if len(unfollow_sheet) == 1:
                Common.logger(log_type).info("暂无定向账号")
            else:
                unfollow_list = []
                nick_list = []
                for i in range(1, len(unfollow_sheet)):
                    profile_mid = unfollow_sheet[i][1]
                    nick = unfollow_sheet[i][2]
                    nick_list.append(nick)
                    unfollow_list.append(profile_mid)
                Common.logger(log_type).info("取消关注用户列表:{}", nick_list)
                return unfollow_list
        except Exception as e:
            Common.logger(log_type).error("从云文档获取取消关注用户列表异常:{}", e)

    # 关注云文档中的用户
    @classmethod
    def sub_users(cls, log_type):
        try:
            profile_mids = cls.get_follow_users(log_type)
            for profile_mid in profile_mids:
                url = "https://api.xiaoniangao.cn/V1/account/sub_user"
                headers = {
                    "x-b3-traceid": str(cls.follow_x_mid),
                    "X-Token-Id": str(cls.follow_x_token_id),
                    "content-type": "application/json",
                    "uuid": str(cls.follow_uid),
                    "Accept-Encoding": "gzip,compress,br,deflate",
                    "User-Agent": "Mozilla/5.0 (iPhone; CPU iPhone OS 14_7_1 like Mac OS X)"
                                  " AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 "
                                  "MicroMessenger/8.0.20(0x18001435) NetType/WIFI Language/zh_CN",
                    "Referer": str(cls.follow_referer)
                }
                data = {
                    "visited_mid": int(profile_mid),
                    "log_common_params": {
                        "e": [{
                            "data": {
                                "page": "profilePage",
                                "topic": "public",
                                "type": "follow",
                                "name": "user",
                                "smid": str(profile_mid)
                            },
                            "ab": {}
                        }],
                        "ext": {
                            "brand": "iPhone",
                            "device": "iPhone 11",
                            "os": "iOS 14.7.1",
                            "weixinver": "8.0.20",
                            "srcver": "2.24.2",
                            "net": "wifi",
                            "scene": "1089"
                        },
                        "pj": "1",
                        "pf": "2",
                        "session_id": "d53b6125-942b-4ec1-8d22-f9451a35e9f9"
                    },
                    "token": str(cls.follow_token),
                    "uid": str(cls.follow_uid),
                    "proj": "ma",
                    "wx_ver": "8.0.20",
                    "code_ver": "3.62.0"
                }
                urllib3.disable_warnings()
                r = requests.post(headers=headers, url=url, json=data, proxies=proxies, verify=False)
                Common.logger(log_type).info("关注用户:{}，{}", profile_mid, r)
        except Exception as e:
            Common.logger(log_type).error("关注云文档中的用户异常:{}", e)

    # 取消关注云文档中的用户
    @classmethod
    def unsub_users(cls, log_type):
        try:
            unsub_profile_mids = cls.get_unfollow_users(log_type)
            for profile_mid in unsub_profile_mids:
                url = "https://api.xiaoniangao.cn/V1/account/unsub_user"
                headers = {
                    "x-b3-traceid": str(cls.follow_x_mid),
                    "X-Token-Id": str(cls.follow_x_token_id),
                    "content-type": "application/json",
                    "uuid": str(cls.follow_uid),
                    "Accept-Encoding": "gzip,compress,br,deflate",
                    "User-Agent": "Mozilla/5.0 (iPhone; CPU iPhone OS 14_7_1 like Mac OS X)"
                                  " AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 "
                                  "MicroMessenger/8.0.20(0x18001435) NetType/WIFI Language/zh_CN",
                    "Referer": str(cls.follow_referer)
                }
                data = {
                    "visited_mid": int(profile_mid),
                    "log_common_params": {
                        "e": [{
                            "data": {
                                "page": "profilePage",
                                "topic": "public",
                                "type": "unfollow",
                                "name": "user",
                                "smid": str(profile_mid)
                            },
                            "ab": {}
                        }],
                        "ext": {
                            "brand": "iPhone",
                            "device": "iPhone 11",
                            "os": "iOS 14.7.1",
                            "weixinver": "8.0.20",
                            "srcver": "2.24.4",
                            "net": "wifi",
                            "scene": "1089"
                        },
                        "pj": "1",
                        "pf": "2",
                        "session_id": "6a2959c7-3f98-411f-8bc9-8d2a8a5c6f16"
                    },
                    "token": str(cls.follow_token),
                    "uid": str(cls.follow_uid),
                    "proj": "ma",
                    "wx_ver": "8.0.20",
                    "code_ver": "3.64.1"}
                urllib3.disable_warnings()
                r = requests.post(headers=headers, url=url, json=data, proxies=proxies, verify=False)
                Common.logger(log_type).info("取消关注:{}，{}", profile_mid, r)
        except Exception as e:
            Common.logger(log_type).error("取消关注云文档中的用户异常:{}", e)

    # 获取个人主页视频
    @classmethod
    def get_videos_from_person(cls, log_type, p_mid):
        try:
            url = "https://api.xiaoniangao.cn/profile/list_album"
            headers = {
                "X-Mid": str(cls.follow_x_mid),
                "X-Token-Id": str(cls.follow_x_token_id),
                "content-type": "application/json",
                "uuid": str(cls.follow_uid),
                "Accept-Encoding": "gzip,compress,br,deflate",
                "User-Agent": "Mozilla/5.0 (iPhone; CPU iPhone OS 14_7_1 like Mac OS X)"
                              " AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 "
                              "MicroMessenger/8.0.20(0x18001435) NetType/WIFI Language/zh_CN",
                "Referer": str(cls.follow_referer)
            }
            json_text = {
                "visited_mid": p_mid,
                "start_t": cls.wechat_person_start_t,
                "qs": "imageMogr2/gravity/center/rotate/$/thumbnail/!690x385r/crop/690x385/interlace/1/format/jpg",
                "h_qs": "imageMogr2/gravity/center/rotate/$/thumbnail/!120x120r/crop/120x120/interlace/1/format/jpg",
                "limit": 20,
                "token": str(cls.follow_token),
                "uid": str(cls.follow_uid),
                "proj": "ma",
                "wx_ver": "8.0.23",
                "code_ver": "3.68.0",
                "log_common_params": {
                    "e": [{
                        "data": {
                            "page": "profilePage",
                            "topic": "public"
                        }
                    }],
                    "ext": {
                        "brand": "iPhone",
                        "device": "iPhone 11",
                        "os": "iOS 14.7.1",
                        "weixinver": "8.0.23",
                        "srcver": "2.24.7",
                        "net": "wifi",
                        "scene": "1089"
                    },
                    "pj": "1",
                    "pf": "2",
                    "session_id": "7468cf52-00ea-432e-8505-6ea3ad7ec164"
                }
            }
            r = requests.post(url=url, headers=headers, json=json_text, proxies=proxies, verify=False)
            cls.wechat_person_start_t = r.json()["data"]["next_t"]
            feeds = r.json()["data"]["list"]
            for i in range(len(feeds)):
                # 标题，表情随机加在片头、片尾，或替代句子中间的标点符号
                char_sheet = Feishu.get_values_batch("hour", "xiaoniangao", "BhlbST")
                expression_list = []
                char_list = []
                for q in range(len(char_sheet)):
                    if char_sheet[q][0] is not None:
                        expression_list.append(char_sheet[q][0])
                    if char_sheet[q][1] is not None:
                        char_list.append(char_sheet[q][1])
                # print(expression_list)
                # print(char_list)
                befor_video_title = feeds[i]["title"].strip().replace("\n", "") \
                    .replace("/", "").replace("\r", "").replace("#", "") \
                    .replace(".", "。").replace("\\", "").replace("&NBSP", "") \
                    .replace(":", "").replace("*", "").replace("？", "") \
                    .replace("?", "").replace('"', "").replace("<", "") \
                    .replace(">", "").replace("|", "").replace(" ", "")
                expression = random.choice(expression_list)
                expression_title_list = [expression + befor_video_title, befor_video_title + expression]
                # 标题，表情随机加在片头
                title_list1 = random.choice(expression_title_list)
                # 标题，表情随机加在片尾
                title_list2 = befor_video_title + random.choice(char_list)
                # 替代句子中间的标点符号
                title_list3 = befor_video_title.replace(
                    ",", random.choice(expression_list)).replace("，", random.choice(expression_list))
                title_list4 = [title_list1, title_list2]
                video_title = random.choice(title_list4)

                # 用户名
                user_name = feeds[i]["album_user"]["nick"].strip().replace("\n", "") \
                    .replace("/", "").replace("快手", "").replace(" ", "") \
                    .replace(" ", "").replace("&NBSP", "").replace("\r", "")

                # 视频 ID
                if "vid" in feeds[i]:
                    video_id = feeds[i]["vid"]
                else:
                    video_id = 0

                # 播放量
                if "play_pv" in feeds[i]:
                    video_play_cnt = feeds[i]["play_pv"]
                else:
                    video_play_cnt = 0

                # 点赞
                if "total" in feeds[i]["favor"]:
                    video_like_cnt = feeds[i]["favor"]["total"]
                else:
                    video_like_cnt = 0

                # 评论数
                if "comment_count" in feeds[i]:
                    video_comment_cnt = feeds[i]["comment_count"]
                else:
                    video_comment_cnt = 0

                # 分享
                if "share" in feeds[i]:
                    video_share_cnt = feeds[i]["share"]
                else:
                    video_share_cnt = 0

                # 时长
                if "du" in feeds[i]:
                    video_duration = int(feeds[i]["du"] / 1000)
                else:
                    video_duration = 0

                # 发布时间
                if "t" in feeds[i]:
                    video_send_time = feeds[i]["t"]
                else:
                    video_send_time = 0
                cls.send_time = video_send_time/1000

                # 宽和高
                if "w" in feeds[i] or "h" in feeds[i]:
                    video_width = feeds[i]["w"]
                    video_height = feeds[i]["h"]
                else:
                    video_width = 0
                    video_height = 0

                # 头像
                if "hurl" in feeds[i]["album_user"]:
                    head_url = feeds[i]["album_user"]["hurl"]
                else:
                    head_url = 0

                # 用户 ID
                if "id" in feeds[i]:
                    profile_id = feeds[i]["id"]
                else:
                    profile_id = 0

                # 用户 mid
                if "mid" in feeds[i]:
                    profile_mid = feeds[i]["mid"]
                else:
                    profile_mid = 0

                # 封面
                if "url" in feeds[i]:
                    cover_url = feeds[i]["url"]
                else:
                    cover_url = 0

                # 视频播放地址
                if "v_url" in feeds[i]:
                    video_url = feeds[i]["v_url"]
                else:
                    video_url = 0

                Common.logger(log_type).info("标题:{}", video_title)
                Common.logger(log_type).info("视频ID:{}", video_id)
                Common.logger(log_type).info("用户名:{}", user_name)
                Common.logger(log_type).info("播放量:{}", video_play_cnt)
                Common.logger(log_type).info(
                    "发布时间:{}", time.strftime("%Y/%m/%d %H:%M:%S", time.localtime(int(video_send_time) / 1000)))
                Common.logger(log_type).info("播放地址:{}", video_url)

                # 过滤无效视频
                if video_id == 0 \
                        or video_title == 0 \
                        or video_send_time == 0 \
                        or video_duration == 0 \
                        or video_url == 0:
                    Common.logger(log_type).info("无效视频\n")
                elif int(time.time()) - int(video_send_time / 1000) >= 259200:
                    Common.logger(log_type).info("发布时间:{}，超过72小时\n", time.strftime(
                        "%Y/%m/%d %H:%M:%S", time.localtime(int(video_send_time) / 1000)))
                    cls.wechat_person_start_t = None
                    break
                elif cls.download_rule(video_duration, video_width, video_height, video_play_cnt,
                                       video_share_cnt) is False:
                    Common.logger(log_type).info("不满足基础门槛\n")
                elif any(word if word in video_title else False for word in
                         cls.sensitive_words(log_type)) is True:
                    Common.logger(log_type).info("视频已中敏感词:{}\n".format(video_title))
                # 从 云文档 去重:https://w42nne6hzg.feishu.cn/sheets/shtcnYxiyQ1wLklo1W5Kdqc9cGh?sheet=yatRv2
                elif video_id in [m for n in Feishu.get_values_batch(log_type, "xiaoniangao", "yatRv2") for m in
                                  n]:
                    Common.logger(log_type).info("该视频已下载:{}\n", video_title)
                # 从 云文档 去重:https://w42nne6hzg.feishu.cn/sheets/shtcnYxiyQ1wLklo1W5Kdqc9cGh?sheet=k6ldje
                elif video_id in [m for n in Feishu.get_values_batch(log_type, "xiaoniangao", "k6ldje") for m in
                                  n]:
                    Common.logger(log_type).info("该视频已在个人主页feeds:{}\n", video_title)
                else:
                    Feishu.insert_columns(log_type, "xiaoniangao", "k6ldje", "ROWS", 1, 2)
                    # 获取当前时间
                    get_feeds_time = int(time.time())
                    # 看一看云文档，工作表中写入数据
                    values = [[time.strftime("%Y/%m/%d %H:%M:%S", time.localtime(int(get_feeds_time))),
                               "用户主页",
                               video_id,
                               video_title,
                               video_play_cnt,
                               video_comment_cnt,
                               video_like_cnt,
                               video_share_cnt,
                               video_duration,
                               str(video_width) + "*" + str(video_height),
                               time.strftime(
                                   "%Y/%m/%d %H:%M:%S", time.localtime(int(video_send_time) / 1000)),
                               user_name,
                               profile_id,
                               profile_mid,
                               head_url,
                               cover_url,
                               video_url]]
                    # 等待 1s，防止操作云文档太频繁，导致报错
                    time.sleep(1)
                    Feishu.update_values(log_type, "xiaoniangao", "k6ldje", "F2:V2", values)
                    Common.logger(log_type).info("添加视频至个人主页feeds成功:{}\n", video_title)

            # Common.logger(log_type).info("cls.send_time:{}", cls.send_time)
            if int(time.time()) - int(cls.send_time) <= 259200:
                cls.get_videos_from_person(log_type, p_mid)
            else:
                cls.wechat_person_start_t = None
                return
        except Exception as e:
            Common.logger(log_type).error("获取个人主页视频异常:{}", e)

    # 获取所有关注列表的用户视频
    @classmethod
    def get_videos_from_follow(cls, log_type):
        try:
            # 已关注的用户列表 mids
            profile_mids = cls.get_sub_or_fans_list(log_type)
            for profile_mid in profile_mids:
                Common.logger(log_type).info("获取用户:{}主页视频\n", profile_mid)
                cls.get_videos_from_person(log_type, profile_mid)
        except Exception as e:
            Common.logger(log_type).error("获取个人主页视频异常:{}", e)

    # 下载/上传
    @classmethod
    def download_publish(cls, log_type, env):
        try:
            person_sheet = Feishu.get_values_batch(log_type, "xiaoniangao", "k6ldje")
            for i in range(1, len(person_sheet)+1):
                time.sleep(1)
                download_video_id = person_sheet[i][7]
                download_video_title = person_sheet[i][8]
                download_video_play_cnt = person_sheet[i][9]
                download_video_comment_cnt = person_sheet[i][10]
                download_video_like_cnt = person_sheet[i][11]
                download_video_share_cnt = person_sheet[i][12]
                download_video_duration = person_sheet[i][13]
                download_video_resolution = person_sheet[i][14]
                download_video_send_time = person_sheet[i][15]
                download_user_name = person_sheet[i][16]
                download_user_id = person_sheet[i][17]
                download_user_mid = person_sheet[i][18]
                download_head_url = person_sheet[i][19]
                download_cover_url = person_sheet[i][20]
                download_video_url = person_sheet[i][21]

                # Common.logger("person").info("download_video_id:{}", download_video_id)
                # Common.logger("person").info("download_video_title:{}", download_video_title)
                # Common.logger("person").info("download_video_play_cnt:{}", download_video_play_cnt)
                # Common.logger("person").info("download_video_comment_cnt:{}", download_video_comment_cnt)
                # Common.logger("person").info("download_video_like_cnt:{}", download_video_like_cnt)
                # Common.logger("person").info("download_video_share_cnt:{}", download_video_share_cnt)
                # Common.logger("person").info("download_video_duration:{}", download_video_duration)
                # Common.logger("person").info("download_video_resolution:{}", download_video_resolution)
                # Common.logger("person").info("download_video_send_time:{}", download_video_send_time)
                # Common.logger("person").info("download_user_name:{}", download_user_name)
                # Common.logger("person").info("download_user_id:{}", download_user_id)
                # Common.logger("person").info("download_user_mid:{}", download_user_mid)
                # Common.logger("person").info("download_head_url:{}", download_head_url)
                # Common.logger("person").info("download_cover_url:{}", download_cover_url)
                # Common.logger("person").info("download_video_url:{}", download_video_url)
                
                Common.logger("person").info("正在判断第{}行，视频:{}", i+1, download_video_title)

                # 过滤空行及空标题视频
                if download_video_id is None \
                        or download_video_id == "" \
                        or download_video_title is None \
                        or download_video_title == "":
                    # 删除行或列，可选 ROWS、COLUMNS
                    Feishu.dimension_range("person", "xiaoniangao", "k6ldje", "ROWS", i + 1, i + 1)
                    Common.logger("person").warning("标题为空或空行，删除成功\n")
                    return
                # 播放量不小于 2000
                elif download_video_play_cnt < 2000:
                    # 删除行或列，可选 ROWS、COLUMNS
                    Feishu.dimension_range("person", "xiaoniangao", "k6ldje", "ROWS", i + 1, i + 1)
                    Common.logger("person").info("播放量:{}<2000，删除成功\n", download_video_play_cnt)
                    return
                # 从已下载视频表中去重
                elif download_video_id in [j for m in Feishu.get_values_batch(
                        "person", "xiaoniangao", "yatRv2") for j in m]:
                    # 删除行或列，可选 ROWS、COLUMNS
                    Feishu.dimension_range("person", "xiaoniangao", "k6ldje", "ROWS", i + 1, i + 1)
                    Common.logger("person").info("视频已下载:{}，删除成功\n", download_video_title)
                    return
                else:
                    # 下载封面
                    Common.download_method(log_type="person", text="cover",
                                           d_name=str(download_video_title), d_url=str(download_cover_url))
                    # 下载视频
                    Common.download_method(log_type="person", text="video",
                                           d_name=str(download_video_title), d_url=str(download_video_url))
                    # 保存视频信息至 "./videos/{download_video_title}/info.txt"
                    with open("./videos/" + download_video_title + "/" + "info.txt",
                              "a", encoding="UTF-8") as f_a:
                        f_a.write(str(download_video_id) + "\n" +
                                  str(download_video_title) + "\n" +
                                  str(download_video_duration) + "\n" +
                                  str(download_video_play_cnt) + "\n" +
                                  str(download_video_comment_cnt) + "\n" +
                                  str(download_video_like_cnt) + "\n" +
                                  str(download_video_share_cnt) + "\n" +
                                  str(download_video_resolution) + "\n" +
                                  str(int(time.mktime(
                                      time.strptime(download_video_send_time, "%Y/%m/%d %H:%M:%S")))) + "\n" +
                                  str(download_user_name) + "\n" +
                                  str(download_head_url) + "\n" +
                                  str(download_video_url) + "\n" +
                                  str(download_cover_url) + "\n" +
                                  "xiaoniangao_person")
                    Common.logger("person").info("==========视频信息已保存至info.txt==========")

                    # 上传视频
                    Common.logger("person").info("开始上传视频:{}".format(download_video_title))
                    our_video_id = Publish.upload_and_publish("person", env, "play")
                    our_video_link = "https://admin.piaoquantv.com/cms/post-detail/" + str(our_video_id) + "/info"
                    Common.logger("person").info("视频上传完成:{}", download_video_title)

                    # 保存视频 ID 到云文档:https://w42nne6hzg.feishu.cn/sheets/shtcnYxiyQ1wLklo1W5Kdqc9cGh?sheet=yatRv2
                    Common.logger("person").info("保存视频ID至云文档:{}", download_video_title)
                    # 视频ID工作表，插入首行
                    Feishu.insert_columns("person", "xiaoniangao", "yatRv2", "ROWS", 1, 2)
                    # 视频ID工作表，首行写入数据
                    upload_time = int(time.time())
                    values = [[time.strftime("%Y/%m/%d %H:%M:%S", time.localtime(upload_time)),
                               "用户主页",
                               str(download_video_id),
                               str(download_video_title),
                               our_video_link,
                               download_video_play_cnt,
                               download_video_comment_cnt,
                               download_video_like_cnt,
                               download_video_share_cnt,
                               download_video_duration,
                               str(download_video_resolution),
                               str(download_video_send_time),
                               str(download_user_name),
                               str(download_user_id),
                               str(download_user_mid),
                               str(download_head_url),
                               str(download_cover_url),
                               str(download_video_url)]]
                    time.sleep(1)
                    Feishu.update_values("person", "xiaoniangao", "yatRv2", "F2:W2", values)

                    # 保存视频信息到监控表
                    Common.logger("person").info("添加视频到监控表:{}", download_video_title)
                    # 插入空行
                    time.sleep(1)
                    Feishu.insert_columns("person", "monitor", "N7e2yI", "ROWS", 1, 2)
                    # 视频信息写入监控表
                    values = [[time.strftime("%Y/%m/%d %H:%M:%S", time.localtime(int(upload_time))),
                               str(download_video_id),
                               download_video_title,
                               our_video_link,
                               download_user_id,
                               download_user_mid,
                               download_user_name,
                               download_video_duration,
                               str(download_video_send_time),
                               download_video_play_cnt]]
                    time.sleep(1)
                    Feishu.update_values("person", "monitor", "N7e2yI", "F2:O2", values)

                    # 删除行或列，可选 ROWS、COLUMNS
                    Feishu.dimension_range("person", "xiaoniangao", "k6ldje", "ROWS", i + 1, i + 1)
                    Common.logger("person").info("视频:{}，下载/上传成功\n", download_video_title)
                    return
        except Exception as e:
            Common.logger(log_type).error("下载/上传异常:{}", e)

    # 执行下载/上传
    @classmethod
    def run_download_publish(cls, log_type, env):
        try:
            while True:
                person_sheet = Feishu.get_values_batch(log_type, "xiaoniangao", "k6ldje")
                if len(person_sheet) == 1:
                    Common.logger(log_type).info("下载/上传完成")
                    break
                else:
                    cls.download_publish(log_type, env)
        except Exception as e:
            Common.logger(log_type).error("执行下载/上传异常:{}", e)


if __name__ == "__main__":
    person = Person()
    # print(person.follow_x_mid)
    # print(person.follow_x_token_id)
    # print(person.follow_referer)
    # print(person.follow_uid)
    # print(person.follow_token)
    # print(person.get_follow_users("person"))
    # print(person.get_unfollow_users("person"))
    # 关注用户
    # person.sub_users("person")
    # # 取消关注用户
    # person.unsub_users("person")
    # # 获取所有关注列表的用户视频
    # person.get_videos_from_follow("person")
    # # 同步关注用户至云文档
    # person.get_sub_or_fans_list("person")
    # 抓取用户主页视频至云文档
    # person.get_videos_from_person("person", "90261331")
    person.download_publish("person", "prod")
